<template>
  <b-field
    :type="{ 'is-danger': $v.password.$error }"
    :message="{
      'Password is required': $v.password.$error && !$v.password.required,
      'Password should have at least 8 characters': $v.password.$error && !$v.password.minLength
    }"
    label="Password">
    <b-input
      v-model="$v.password.$model"
      type="password"
      size="is-medium"
      password-reveal
    />
  </b-field>
</template>

<script>
import { requiredIf, minLength } from 'vuelidate/lib/validators'

export default {
  props: {
    value: {
      type: String,
      default: ''
    },
    required: {
      type: Boolean,
      default: false
    }
  },
  validations: {
    password: { required: requiredIf('isRequired'), minLength: minLength(8) }
  },
  computed: {
    password: {
      get () {
        return this.value
      },

      set (value) {
        this.$emit('input', value)
      }
    },
    isRequired () {
      return this.required
    }
  }
}
</script>
